// MMSChecksum.h
//
//

#import <Foundation/Foundation.h>

@interface MMSChecksum: NSObject <NSCopying, NSCoding>
{
@private
	unsigned char *_checksum;
    void *_context; // Hide type from implementation!
}

// Creating an instance

+ (MMSChecksum *)checksumForFileAtPath:(NSString *)aPath;
+ (MMSChecksum *)checksumWithValue:(NSData *)aValue; // aValue is the checksum value
+ (id)objectWithArchiveData:(NSString *)aString;

- (id)init;

- (void)dealloc;

// Setting the derived checksum

- (void)setChecksumForFileAtPath:(NSString *)aPath;
- (void)setChecksumForData:(NSData *)someData;

// Debugging aid

- (NSString *)description;

// Testing for equality

- (BOOL)isEqual:(id)anObject;

- (BOOL)isEqualToChecksum:(MMSChecksum *)aChecksum;

@end

@interface MMSChecksum (Calculation)

// Piecemeal calculation of checksum.

- (void)prepareChecksumCalculation;
- (void)updateCalculationWithData:(NSData *)someData;
- (void)finishCalculation;

@end
