/* MMSLocationPlottingView */

#import <Cocoa/Cocoa.h>

@interface MMSLocationPlottingView : NSImageView
{
    NSMutableArray *locationMarkerArray;
    NSImage *markerImage;
    NSPoint markerHotSpot;
    NSPoint grabOrigin;
    NSPoint scrollOrigin;
    id selectedLocation;
    
    BOOL sizeToFit;
}

//
// Setup
//
- (void)performDefaultConfiguration;

//
// Drawing methods
//
- (void)drawMarkerUsingLocation:(id)aLocation;
- (NSRect)originMarkerRect;
- (void)clearAllMarkers;
- (void)addMarker:(id)aMarker;
- (NSPoint)plotPointForLocation:(id)aLocation;
- (void)scrollToShowLocation:(id)aLocation;

//
// Accessors
//
- (NSMutableArray *)locationMarkerArray;
- (void)setLocationMarkerArray:(NSMutableArray *)aLocationMarkerArray;

- (NSPoint)markerHotSpot;
- (void)setMarkerHotSpot:(NSPoint)aMarkerHotSpot;

- (NSImage *)markerImage;
- (void)setMarkerImage:(NSImage *)aMarkerImage;

- (id)selectedLocation;
- (void)setSelectedLocation:(id)aSelectedLocation;

- (BOOL)sizeToFit;
- (void)setSizeToFit:(BOOL)flag;



@end
