//
//  MMSPhotoCollectionLink.h
//  MMSBase
//
//  Created by John Fox on 4/4/08.
//  Copyright 2008 GroupSmarts, LLC. All rights reserved.
//

#import "MMSPersistentObject.h"

#import <Foundation/Foundation.h>
#import "MMSPhoto.h"
#import "MMSOrderedCollection.h"

@interface MMSPhotoCollectionLink : MMSPersistentObject
{
    NSNumber *orderIndex;
    
    MMSPhoto *photo;
    MMSOrderedCollection *collection;
}

+ (MMSPhotoCollectionLink *)photoLinkForCollection:(MMSOrderedCollection *)aCollection
										 withPhoto:(MMSPhoto *)aPhoto
									  atOrderIndex:(NSNumber *)anOrderIndex;


- (NSNumber *)orderIndex;
- (void)setOrderIndex:(NSNumber *)anOrderIndex;

- (MMSPhoto *)photo;
- (void)setPhoto:(MMSPhoto *)aPhoto;

- (MMSOrderedCollection *)collection;
- (void)setCollection:(MMSOrderedCollection *)aCollection;

@end
