//
//  MMSRESTInvocation.h
//  MMSBase
//
//  Created by John Fox on 12/19/2006.
//  Copyright 2006 GroupSmarts, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "MMSWebServiceInvocation.h"

@interface MMSRESTInvocation : MMSWebServiceInvocation 
{
    BOOL isXMLResponse;
    NSDictionary *xmlDataResponseDict;
    NSString *createdObjectUUID;
	NSDictionary *responseHeaderDict;
    MMSRESTInvocation *secondaryInvocation;
    NSInteger finalStatusCode;
}

+ (id)newWithURL:(NSURL *)anURL
xmlMessageString:(NSString *)anXMLString
      httpMethod:(NSString *)anHTTPMethod;

+ (NSString *)xmlStringFromInfoDict:(NSDictionary *)anInfoDict;

- (NSDictionary *)performSyncRequest;

//
// Parsing Support
//
- (void)parseXMLDataResponse;

//
// Accessors
//
- (NSString *)createdObjectUUID;
- (void)setCreatedObjectUUID:(NSString *)aUUID;

- (id)delegate;
- (void)setDelegate:(id)aDelegate;

- (NSInteger)finalStatusCode;
- (void)setFinalStatusCode:(NSInteger)aFinalStatusCode;

- (BOOL)isXMLResponse;

- (NSDictionary *)responseHeaderDict;
- (void)setResponseHeaderDict:(NSDictionary *)aResponseHeaderDict;

- (MMSRESTInvocation *)secondaryInvocation;
- (void)setSecondaryInvocation:(MMSRESTInvocation *)aSecondaryInvocation;

- (NSDictionary *)xmlDataResponseDict;
- (void)setXmlDataResponseDict:(NSDictionary *)aDict;

@end
