//
//  DataCrux-Private.h
//  DataCrux
//
//  Created by Scott Stevenson on Wed Sep 24 2003.
//  Copyright (c) 2003 Tree House Ideas. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface DataCrux (Private)


// client properties and database file

- (NSDictionary *)   clientProperties;
- (DC_SQLDatabase *) clientDatabase;

- (void) setClientProperties:   (NSDictionary *)   clientProperties;
// - (void) setClientDatabase:     (DC_SQLDatabase *) newDatabase;


- (DC_SQLDatabase *) keyDatabase;
- (DC_SQLDatabase *) diskDatabase;
- (DC_SQLDatabase *) memoryDatabase;

- (void) setKeyDatabase:        (DC_SQLDatabase *)   keyDB;
- (void) setDiskDatabase:       (DC_SQLDatabase *)   diskDB;
- (void) setMemoryDatabase:     (DC_SQLDatabase *)   memoryDB;



// path finding

- (NSString *)      clientPropertiesPath;
- (NSString *)      clientDatabasePath;
- (NSString *)      pathForNewClientDatabase;

- (DC_SQLDatabase *)   databaseWithPath: (NSString *)thePath;


// pipeline controller

- (THI_PipelineController *) pipelineController;
- (void) setPipelineController: (THI_PipelineController *)newController;


- (void) setTransactionIsActive: (BOOL) isActive;

@end




