var myPoint;
var personPolylineHash = new Hash();
var currentMarker = null;
var currentMarkerIndex = 0;
var currentPolyline;
var colorMapArray;
var markerManager;
var mapControlller = undefined;

function initialize()
{
    //testPolylines();
    markerManager = new MarkerManager(map);
    
    //log('markerManager is ' +markerManager);
    
    //testMarkers();
    //setTimeout("removeLifelineForPersonWithID(\'123\')", 5000);
    //setTimeout("removeLifelineForPersonWithID(\'456\')", 7000);
    //setTimeout("togglePolylineForPersionWithID(\'123\')", 2000);
    //setTimeout("togglePolylineForPersionWithID(\'456\')", 5000);
    
    //setTimeout("clearAllMarkersAndLines();", 5000);

}

function clearAllMarkersAndLines()
{
    markerManager.clearMarkers();
    map.clearOverlays();
}

function performMarkerTest()
{
    log('here in performMarkerTest()');
    testMarkers();
    setTimeout("togglePolylineForPersionWithID(\'123\')", 2000);
    setTimeout("togglePolylineForPersionWithID(\'456\')", 5000);
}

function willShowPolyline(aPolyline)
{
    if (currentPolyline != undefined)
        currentPolyline.hide();
    
    currentPolyline = aPolyline;
}

function testMarkers()
{
    myPoint = new GLatLng(37.7481, -122.419);

    addMarkerPointForPersonWithID(myPoint, '123', 'Some Description<br>Some Description<br>Some Description<br>Some Description<br>Some Description<br>', 'John Fox');
    
    myPoint = new GLatLng(20.65389, -156.441225);
    
    addMarkerPointForPersonWithID(myPoint, '123', 'Some Other Description', 'John Fox');
    
    myPoint = new GLatLng(48.87698, 2.337813);
    
    createEncodedPolylineForPersonWithID('123', getRandomHexColor());
    
    addMarkerPointForPersonWithID(myPoint, '456', 'Still Another Description', 'Richard Fox');
    
    myPoint = new GLatLng(37.7642, -122.4553);
    
    addMarkerPointForPersonWithID(myPoint, '456', 'Would you believe yet another description?', 'Richard Fox');
    
    createEncodedPolylineForPersonWithID('456', getRandomHexColor());
}

function log(aString)
{
    if (mapController != undefined)
    {
        mapController.logMessage(aString);
    }
    else if (window.console != undefined)
    {
        window.console.log(aString);
    }

}

function hideAllLifelines()
{
    mapController.logMessage('here in hideAllLifelines');
    
    personPolylineHash.each(function(aPersonHash)
    {
        mapController.logMessage('in hideAllLifelines aPersonHash.key is ' +aPersonHash.key);
        
        toggleLifelineForPersonWithID(aPersonHash.key, false, false);
        //togglePolylineForPersionWithID(aPersonHash.key);
    });
}

function showAllLifelines()
{
    //log('here in showAllLifelines');
    
    personPolylineHash.each(function(aPersonHash)
    {        
        toggleLifelineForPersonWithID(aPersonHash.key, true, false);
        //togglePolylineForPersionWithID(aPersonHash.key);
    })
}


function toggleLifelineForPersonWithID(aPersonID, isShow, zoomMap)
{
    var myPersonHash = personPolylineHash.get(aPersonID);
    
    //mapController.logMessage('toggleLifelineForPersonWithID aPersonID is ' +aPersonID +' isShow is ' +isShow);
    
    if (myPersonHash != undefined)
    {
        //mapController.logMessage('we have a personHash');

        var myPolyline = myPersonHash.get('polyline');
        
        if (myPolyline != undefined)
        {
            //mapController.logMessage('myPolyline is not undefined');

            if (isShow == true)
            {
                //log('about to get the polyline bounds myPolyline.getVertexCount() is ' +myPolyline.getVertexCount());
                
                if (zoomMap == true)
                {
                    var polylineBounds = myPolyline.getBounds();
                    
                    //log('will show a polyline polylineBounds is ' +polylineBounds);
    
                    var zoomLevel = map.getBoundsZoomLevel(polylineBounds, map.getSize());	
                    
                    //log('zoomLevel is ' +zoomLevel);
    
                    map.setCenter(polylineBounds.getCenter(), zoomLevel);
                }
                myPolyline.show();
            }
            else
            {
                myPolyline.hide();
            }
        }
        
        var myMarkerArray = myPersonHash.get('markerArray');
        
        //log('myMarkerArray is ' +myMarkerArray);
        
        if (myMarkerArray != undefined)
        {
            //log('we have a markerArray its first object is ' +myMarkerArray[0].getPoint());
        
            myMarkerArray.each(function(aMarker)
            {
               //log('aMarker is ' +aMarker.getPoint() +' aMarker.isHidden() is ' +aMarker.isHidden() +' isShow is ' +isShow);

                if (isShow == true)
                {
                    map.addOverlay(aMarker);
                    aMarker.show();
                }
                else
                {
                    aMarker.hide();
                }
            });
        }
    }
}

function removeLifelineForPersonWithID(aPersonID)
{
    var myPersonHash = personPolylineHash.get(aPersonID);
    
    //log('removeLifelineForPersonWithId aPersonID is ' +aPersonID);
    
    if (myPersonHash != undefined)
    {
        //log('we have a personHash');

        var myPolyline = myPersonHash.get('polyline');
        
        if (myPolyline != undefined)
        {
            //log('myPolyline is not undefined');

            map.removeOverlay(myPolyline);
        }
        
        var myMarkerArray = myPersonHash.get('markerArray');
        
        //mapController.logMessage('myMarkerArray is ' +myMarkerArray);
        
        if (myMarkerArray != undefined)
        {
            //log('we have a markerArray its first object is ' +myMarkerArray[0].getPoint());
        
            myMarkerArray.each(function(aMarker)
            {
                //mapController.logMessage('will remove this marker ' +aMarker);
                aMarker.hide();
                map.removeOverlay(aMarker);
            });
        }
    }
        
    personPolylineHash.unset(aPersonID);
}

function togglePolylineForPersionWithID(aPersonID)
{
    //log('here in togglePolylineForPersionWithID aPersonID is ' +aPersonID);
    
    var myPersonHash = personPolylineHash.get(aPersonID);
    
    if (myPersonHash != undefined)
    {
        var myPolyline = myPersonHash.get('polyline');
        
        if (myPolyline != undefined)
        {
           // log('will see if the polyline is hidden');
            //log('myPolyline.isHidden() is ' +myPolyline.isHidden());

            if (myPolyline.isHidden() == true)
            {
                var polylineBounds = myPolyline.getBounds();
                var zoomLevel = map.getBoundsZoomLevel(polylineBounds, map.getSize());	
    
                map.setCenter(polylineBounds.getCenter(), zoomLevel);
                
                //willShowPolyline(myPolyline);
                myPolyline.show();
            }
            else
            {
                myPolyline.hide();
            }
        }
    }
}

function addMarkerPointForPersonWithID(aMarkerPoint, aPersonID, aDescription, aPersonName, aMarkerID)
{
    var myPersonHash = personPolylineHash.get(aPersonID);
    var myPolyline;
    var myMarkerArray;
    
    //log('here in addMarkerPointForPersonWithID aMarkerPoint is ' +typeof(aMarkerPoint));
    
    if (myPersonHash == undefined)
    {
        myPersonHash = new Hash();
        myPersonHash.set('markerArray', new Array());
        
        personPolylineHash.set(aPersonID, myPersonHash);
    }
                
    myMarkerArray = myPersonHash.get('markerArray');
    
    var markerIcon = new GIcon(); 
        markerIcon.image = "pushPinSmall.png"; 
    //markerIcon.shadow = "path to your icon shadow"; 
    markerIcon.iconSize = new GSize(20, 28); 
    //markerIcon.shadowSize = new GSize(22, 20); 
    markerIcon.iconAnchor = new GPoint(11, 20); 
    //markerIcon.infoWindowAnchor = new GPoint(6, 1); 
    //markerIcon.infoShadowAnchor = new GPoint(13, 13); 
    
    // {draggable: false}
    //
    var myMarker = new GMarker(aMarkerPoint, markerIcon);
    
    //log('myMarkerArray before adding has ' +myMarkerArray.length +' markers will add this new marker ' +myMarker.getPoint());
    
    myMarkerArray[myMarkerArray.length] = myMarker;
    
    //  class=\"markerDescription\"
    var html = ""
    
    //log('aDescription is ' +aDescription);
    
    if (aDescription.length)
    {
        //html += "<div class=\"markerDescription\">" +aDescription +"</div>";
        html += "<div style=\"padding-left: 2px; height:80px; margin-top:5px; overflow:auto; font-family: Verdana; font-size: 0.80em; border: 1px solid #dddddd;\">" +aDescription;
    }
    
    html += "</div>";
        
    html += "<div style=\"margin-top:5px; font-family: Verdana; font-size: 0.80em;\"><a href=\"javascript:goToNextOrPriorMarker(\'" +aPersonID +"\' , '" +(myMarkerArray.length -1) +"\');\">Show Next</a>";
    
    html += " | <a href=\"javascript:zoomOutForPerson(\'" +aPersonID +"\');\">Zoom Out</a></div>";
    
    if (aPersonName)
    {
        html += "<div style=\"margin-top:5px; font-family: Verdana; font-size: 0.80em;\">" +aPersonName +"</div>";
    }
    
    myMarker.p_html = html;
    myMarker.markerID = aMarkerID;
         
    //window.setTimeout(function(){
    //myMarker.openInfoWindowHtml(myMarker.p_html, {maxWidth : 50});}, 0)
   
    GEvent.addListener(myMarker, "click", function() 
    {
        var zoomFactor = map.getZoom();
        currentMarkerIndex = (myMarkerArray.length -1);
        
        if (map.getZoom() < 14);
        {
            mapController.logMessage('needToZoom is true? ');
            zoomFactor = 14;
        }

        map.setCenter(myMarker.getPoint())
        
        mapController.logMessage('map.getZoom() ' +map.getZoom());

        currentMarker = myMarker;
        window.setTimeout(function(){
            mapController.didClickOnMarker(aMarkerID);}, 0);
    });

/*    GEvent.addListener(myMarker, "mouseover", function() 
    {
        //log('did mouseover of marker ' +myMarker);
        myMarker.openInfoWindowHtml(myMarker.p_html, {maxWidth : 50});
    });
    */

/*    GEvent.addListener(map, "mouseout", function(overlay, point) {
        if (overlay != null)
        {
            //if (typeof(overlay))
            log('did mouseout of marker ' +typeof(overlay));
        }
    });
    */
        
    //myMarkerArray[myMarkerArray.length] = myMarker;

 /*   myPolyline = myPersonHash.get('polyline');
    
    if (myPolyline == undefined)
    {
        var myColor = getRandomHexColor();
        //log('myColor is ' +myColor);
        
        myPolyline = new GPolyline(new Array(aMarkerPoint), myColor, 5, .8);
        myPersonHash.set('polyline', myPolyline);
        
        map.addOverlay(myPolyline);
    }
    else
    {
        myPolyline.insertVertex(myMarkerArray.length, aMarkerPoint)	
    }
    */
    
    //log('about to call addMarker on the markerManager');
    
    markerManager.addMarker(myMarker, 0);
    map.addOverlay(myMarker);
    //myMarker.show();
    //myPolyline.hide();
}
 
function createEncodedPolylineForPersonWithID(aPersonID, aColor)
{
    var myPersonHash = personPolylineHash.get(aPersonID);
    var myMarkerArray = myPersonHash.get('markerArray');
    var myPointArray = new Array();
        
    myMarkerArray.each(function(aMarker)
    {
        myPointArray.push(aMarker.getPoint());
    });
        
    var myEncoder = new PolylineEncoder();
    var myPolyline = myEncoder.dpEncodeToGPolyline(myPointArray, aColor, 4, .5);
    
    //log('did create this polyline' +myPolyline.toString());
    
    myPersonHash.set('polyline', myPolyline);
        
    map.addOverlay(myPolyline);
    myPolyline.show();
}

function goToNextOrPriorMarker(aPersonID, isPrior)
{
    var myPersonHash = personPolylineHash.get(aPersonID);
    var nextIndex = (parseInt(currentMarkerIndex) + 1);
    var myMarker;
    
    log('here in goNextOrPriorMarker');
    
    if (isPrior)
    {
        nextIndex = (parseInt(currentMarkerIndex) - 1);
    }
    
    log('here in goToNextMarker aPersonID is ' +aPersonID +' nextIndex is ' +nextIndex);

    if (myPersonHash == undefined)
        return;
        
    var myMarkerArray = myPersonHash.get('markerArray');
    
    log('markerArray has ' +myMarkerArray.length +' items');    
    
    if (nextIndex > (myMarkerArray.length - 1))
        nextIndex = 0;
        
    if (nextIndex < 0)
        nextIndex = (myMarkerArray.length - 1);
    
    currentMarkerIndex = nextIndex;
    
    //log('nextIndex is ' +nextIndex);

    myMarker = myMarkerArray[nextIndex];

   log('will pan to this marker point ' +myMarker.getPoint());

    map.panTo(myMarker.getPoint());
    
    currentMarker = myMarker;
    
    if (map.getZoom() < 12)
    {
        map.setZoom(12);
    }
    
    mapController.didClickOnMarker(myMarker.markerID);
}

function zoomOutToZeroZero()
{
    centerPoint = new GLatLng(0,0);
    zoomLevel = 0;
    
    map.setCenter(centerPoint, zoomLevel);
    mapController.setCurrentZoomLevel(zoomLevel);
}

function zoomOutForPerson(aPersonID)
{
    var myPersonHash = personPolylineHash.get(aPersonID);
    
    if (myPersonHash == undefined)
        return zoomOutToZeroZero();
        
    var myPolyline = myPersonHash.get('polyline');

    var zoomLevel = 3;
    var centerPoint = null;
    
    if (myPolyline)
    {
        var polylineBounds = myPolyline.getBounds();
        zoomLevel = map.getBoundsZoomLevel(polylineBounds, map.getSize());	
        centerPoint = polylineBounds.getCenter();
    }
    else
    {
        var markerArray = myPersonHash.get('markerArray');
        
        if (markerArray)
        {
            centerPoint = markerArray[0].getPoint();
        }
        else
        {
            centerPoint = new GLatLng(0,0);
            zoomLevel = 2;
        }
    }

    map.setCenter(centerPoint, zoomLevel);
    
    mapController.setCurrentZoomLevel(zoomLevel);
    
    myPolyline.show();
}

function getRandomHexColor()
{
    var myColor = "#";
    
    if (colorMapArray == undefined)
    {
        colorMapArray = new Array(14);
        colorMapArray[0]="0";
        colorMapArray[1]="1";
        colorMapArray[2]="2";
        colorMapArray[3]="3";
        colorMapArray[4]="4";
        colorMapArray[5]="5";
        colorMapArray[5]="6";
        colorMapArray[6]="7";
        colorMapArray[7]="8";
        colorMapArray[8]="9";
        colorMapArray[9]="A";
        colorMapArray[10]="B";
        colorMapArray[11]="C";
        colorMapArray[12]="D";
        colorMapArray[13]="E";
        colorMapArray[14]="F";
    }
    
    for (i = 0; i < 6; i++)
    {
        myColor += colorMapArray[Math.round(Math.random()*14)]
    }
    
    return myColor;
}

/*
    <georss:point>20.65389 -156.441225</georss:point>
    <georss:featurename>Makena Beach, Maui</georss:featurename>
    
                <georss:point>20.744124 -156.447543</georss:point>
            <georss:featurename>Kihei</georss:featurename>
            
                        <georss:point>20.744124 -156.447543</georss:point>
            <georss:featurename>Kihei</georss:featurename>
            
                        <georss:point>48.87698 2.337813</georss:point>
            <georss:featurename>Suzie&apos;s Paris Apt</georss:featurename>
            
            <georss:point>37.7642 -122.4553</georss:point>
            <georss:featurename>UCSF Hospital</georss:featurename>




*/